image: node:18-alpine3.16

stages:
  - test
  - build
  - publish

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/

before_script:
  - npm install

##############
# TEST STAGE #
##############

test:
  stage: test
  script:
    - npm run lint:check
    - npm run pretty:check
    - npm run test:cov
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $CI_DEFAULT_BRANCH || $CI_COMMIT_MESSAGE =~ /--check/ || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: always

##############
# BUILD STAGE #
##############

build:
  stage: build
  script:
    - npm run build
  artifacts:
    paths:
      - dist
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $CI_DEFAULT_BRANCH || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_TAG'
      when: always

#################
# PUBLISH STAGE #
#################

publish:
  stage: publish
  needs:
    - job: build
      artifacts: true
  dependencies:
    - build
  script:
    - echo "@mobicoop:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/" > .npmrc
    - echo "//${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
    - npm publish
  rules:
    - if: $CI_COMMIT_TAG
      when: always
